--- CVS/cperl-mode.el	2003-02-04 14:24:34.000000000 +0100
+++ pfeiffer/cperl-mode.el	2003-02-11 23:00:28.000000000 +0100
@@ -2368,134 +2352,134 @@
 	      (not (get-text-property (point) 'indentable)))
 	 ;; before start of POD - whitespace found since do not have 'pod!
 	 (and (looking-at "[ \t]*\n=")
-	      (error "Spaces before pod section!"))
+	      (error "Spaces before POD section!"))
 	 (and (not cperl-indent-left-aligned-comments)
 	      (looking-at "^#")))
 	nil
-     (beginning-of-line)
-     (let ((indent-point (point))
-	   (char-after (save-excursion
-			   (skip-chars-forward " \t")
-			   (following-char)))
-	   (in-pod (get-text-property (point) 'in-pod))
-	   (pre-indent-point (point))
-	   p prop look-prop is-block delim)
-      (cond
-       (in-pod
-	;; In the verbatim part, probably code example.  What to do???
-	)
-       (t
-	(save-excursion
-	  ;; Not in pod
-	  (cperl-backward-to-noncomment nil)
-	  (setq p (max (point-min) (1- (point)))
-		prop (get-text-property p 'syntax-type)
-		look-prop (or (nth 1 (assoc prop cperl-look-for-prop))
-			      'syntax-type))
-	  (if (memq prop '(pod here-doc format here-doc-delim))
+      (beginning-of-line)
+      (let ((indent-point (point))
+	    (char-after (save-excursion
+			  (skip-chars-forward " \t")
+			  (following-char)))
+	    (in-pod (get-text-property (point) 'in-pod))
+	    (pre-indent-point (point))
+	    p prop look-prop is-block delim)
+	(cond
+	 (in-pod
+	  ;; In the verbatim part, probably code example.  What to do???
+	  )
+	 (t
+	  (save-excursion
+	    ;; Not in POD
+	    (cperl-backward-to-noncomment nil)
+	    (setq p (max (point-min) (1- (point)))
+		  prop (get-text-property p 'syntax-type)
+		  look-prop (or (nth 1 (assoc prop cperl-look-for-prop))
+				'syntax-type))
+	    (if (memq prop '(pod here-doc format here-doc-delim))
+		(progn
+		  (goto-char (or (previous-single-property-change p look-prop)
+				 (point-min)))
+		  (beginning-of-line)
+		  (setq pre-indent-point (point)))))))
+	(goto-char pre-indent-point)
+	(let* ((case-fold-search nil)
+	       (s-s (cperl-get-state (car parse-data) (nth 1 parse-data)))
+	       (start (or (nth 2 parse-data)
+			  (nth 0 s-s)))
+	       (state (nth 1 s-s))
+	       (containing-sexp (car (cdr state)))
+	       old-indent)
+	  (if (and
+	       ;;containing-sexp		;; We are buggy at toplevel :-(
+	       parse-data)
 	      (progn
-		(goto-char (or (previous-single-property-change p look-prop)
-			       (point-min)))
-		(beginning-of-line)
-		(setq pre-indent-point (point)))))))
-      (goto-char pre-indent-point)
-      (let* ((case-fold-search nil)
-	     (s-s (cperl-get-state (car parse-data) (nth 1 parse-data)))
-	     (start (or (nth 2 parse-data)
-			(nth 0 s-s)))
-	     (state (nth 1 s-s))
-	     (containing-sexp (car (cdr state)))
-	     old-indent)
-	(if (and
-	     ;;containing-sexp		;; We are buggy at toplevel :-(
-	     parse-data)
-	    (progn
-	      (setcar parse-data pre-indent-point)
-	      (setcar (cdr parse-data) state)
-	      (or (nth 2 parse-data)
-		  (setcar (cddr parse-data) start))
-	      ;; Before this point: end of statement
-	      (setq old-indent (nth 3 parse-data))))
-	(cond ((get-text-property (point) 'indentable)
-	       ;; indent to just after the surrounding open,
-	       ;; skip blanks if we do not close the expression.
-	       (goto-char (1+ (previous-single-property-change (point) 'indentable)))
-	       (or (memq char-after (append ")]}" nil))
-		   (looking-at "[ \t]*\\(#\\|$\\)")
-		   (skip-chars-forward " \t"))
-	       (current-column))
-	      ((or (nth 3 state) (nth 4 state))
-	       ;; return nil or t if should not change this line
-	       (nth 4 state))
-	      ;; XXXX Do we need to special-case this?
-	      ((null containing-sexp)
-	       ;; Line is at top level.  May be data or function definition,
-	       ;; or may be function argument declaration.
-	       ;; Indent like the previous top level line
-	       ;; unless that ends in a closeparen without semicolon,
-	       ;; in which case this line is the first argument decl.
-	       (skip-chars-forward " \t")
-	       (+ (save-excursion
-		    (goto-char start)
-		    (- (current-indentation)
-		       (if (nth 2 s-s) cperl-indent-level 0)))
-		  (if (= char-after ?{) cperl-continued-brace-offset 0)
-		  (progn
-		    (cperl-backward-to-noncomment (or old-indent (point-min)))
-		    ;; Look at previous line that's at column 0
-		    ;; to determine whether we are in top-level decls
-		    ;; or function's arg decls.  Set basic-indent accordingly.
-		    ;; Now add a little if this is a continuation line.
-		    (if (or (bobp)
-			    (eq (point) old-indent) ; old-indent was at comment
-			    (eq (preceding-char) ?\;)
-			    ;;  Had ?\) too
-			    (and (eq (preceding-char) ?\})
-				 (cperl-after-block-and-statement-beg
-				  (point-min)))	; Was start - too close
-			    (memq char-after (append ")]}" nil))
-			    (and (eq (preceding-char) ?\:) ; label
-				 (progn
-				   (forward-sexp -1)
-				   (skip-chars-backward " \t")
-				   (looking-at "[ \t]*[a-zA-Z_][a-zA-Z_0-9]*[ \t]*:"))))
-			(progn
-			  (if (and parse-data
-				   (not (eq char-after ?\C-j)))
-			      (setcdr (cddr parse-data)
-				      (list pre-indent-point)))
-			  0)
-		      cperl-continued-statement-offset))))
-	      ((not
-		(or (setq is-block
-			  (and (setq delim (= (char-after containing-sexp) ?{))
-			       (save-excursion ; Is it a hash?
-				 (goto-char containing-sexp)
-				 (cperl-block-p))))
-		    cperl-indent-parens-as-block))
-	       ;; group is an expression, not a block:
-	       ;; indent to just after the surrounding open parens,
-	       ;; skip blanks if we do not close the expression.
-	       (goto-char (1+ containing-sexp))
-	       (or (memq char-after (append ")]}" nil))
-		   (looking-at "[ \t]*\\(#\\|$\\)")
-		   (skip-chars-forward " \t"))
-	       (current-column))
-	      ((progn
-		 ;; Containing-expr starts with \{.  Check whether it is a hash.
-		 (goto-char containing-sexp)
-		 (not (cperl-block-p)))
-	       (goto-char (1+ containing-sexp))
-	       (or (memq char-after
-			 (append (if delim "}" ")]}") nil))
-		   (looking-at "[ \t]*\\(#\\|$\\)")
-		   (skip-chars-forward " \t"))
-	       (+ (current-column)
-		  (if (and delim
-			   (eq char-after ?\}))
-		      ;; Correct indentation of trailing ?\}
-		      (+ cperl-indent-level cperl-close-paren-offset)
-		    0)))
+		(setcar parse-data pre-indent-point)
+		(setcar (cdr parse-data) state)
+		(or (nth 2 parse-data)
+		    (setcar (cddr parse-data) start))
+		;; Before this point: end of statement
+		(setq old-indent (nth 3 parse-data))))
+	  (cond ((get-text-property (point) 'indentable)
+		 ;; indent to just after the surrounding open,
+		 ;; skip blanks if we do not close the expression.
+		 (goto-char (1+ (previous-single-property-change (point) 'indentable)))
+		 (or (memq char-after (append ")]}" nil))
+		     (looking-at "[ \t]*\\(#\\|$\\)")
+		     (skip-chars-forward " \t"))
+		 (current-column))
+		((or (nth 3 state) (nth 4 state))
+		 ;; return nil or t if should not change this line
+		 (nth 4 state))
+		;; XXXX Do we need to special-case this?
+		((null containing-sexp)
+		 ;; Line is at top level.  May be data or function definition,
+		 ;; or may be function argument declaration.
+		 ;; Indent like the previous top level line
+		 ;; unless that ends in a closeparen without semicolon,
+		 ;; in which case this line is the first argument decl.
+		 (skip-chars-forward " \t")
+		 (+ (save-excursion
+		      (goto-char start)
+		      (- (current-indentation)
+			 (if (nth 2 s-s) cperl-indent-level 0)))
+		    (if (= char-after ?{) cperl-continued-brace-offset 0)
+		    (progn
+		      (cperl-backward-to-noncomment (or old-indent (point-min)))
+		      ;; Look at previous line that's at column 0
+		      ;; to determine whether we are in top-level decls
+		      ;; or function's arg decls.  Set basic-indent accordingly.
+		      ;; Now add a little if this is a continuation line.
+		      (if (or (bobp)
+			      (eq (point) old-indent) ; old-indent was at comment
+			      (eq (preceding-char) ?\;)
+			      ;;  Had ?\) too
+			      (and (eq (preceding-char) ?\})
+				   (cperl-after-block-and-statement-beg
+				    (point-min))) ; Was start - too close
+			      (memq char-after (append ")]}" nil))
+			      (and (eq (preceding-char) ?\:) ; label
+				   (progn
+				     (forward-sexp -1)
+				     (skip-chars-backward " \t")
+				     (looking-at "[ \t]*[a-zA-Z_][a-zA-Z_0-9]*[ \t]*:"))))
+			  (progn
+			    (if (and parse-data
+				     (not (eq char-after ?\C-j)))
+				(setcdr (cddr parse-data)
+					(list pre-indent-point)))
+			    0)
+			cperl-continued-statement-offset))))
+		((not
+		  (or (setq is-block
+			    (and (setq delim (= (char-after containing-sexp) ?{))
+				 (save-excursion ; Is it a hash?
+				   (goto-char containing-sexp)
+				   (cperl-block-p))))
+		      cperl-indent-parens-as-block))
+		 ;; group is an expression, not a block:
+		 ;; indent to just after the surrounding open parens,
+		 ;; skip blanks if we do not close the expression.
+		 (goto-char (1+ containing-sexp))
+		 (or (memq char-after (append ")]}" nil))
+		     (looking-at "[ \t]*\\(#\\|$\\)")
+		     (skip-chars-forward " \t"))
+		 (current-column))
+		((progn
+		   ;; Containing-expr starts with \{.  Check whether it is a hash.
+		   (goto-char containing-sexp)
+		   (not (cperl-block-p)))
+		 (goto-char (1+ containing-sexp))
+		 (or (memq char-after
+			   (append (if delim "}" ")]}") nil))
+		     (looking-at "[ \t]*\\(#\\|$\\)")
+		     (skip-chars-forward " \t"))
+		 (+ (current-column)
+		    (if (and delim
+			     (eq char-after ?\}))
+			;; Correct indentation of trailing ?\}
+			(+ cperl-indent-level cperl-close-paren-offset)
+		      0)))
 ;;;	      ((and (/= (char-after containing-sexp) ?{)
 ;;;		    (not cperl-indent-parens-as-block))
 ;;;	       ;; line is expression, not statement:
@@ -2519,151 +2503,151 @@
 ;;;		  (if (eq char-after ?\}) (+ cperl-indent-level
 ;;;					     cperl-close-paren-offset)
 ;;;		    0)))
-	      (t
-	       ;; Statement level.  Is it a continuation or a new statement?
-	       ;; Find previous non-comment character.
-	       (goto-char pre-indent-point)
-	       (cperl-backward-to-noncomment containing-sexp)
-	       ;; Back up over label lines, since they don't
-	       ;; affect whether our line is a continuation.
-	       ;; (Had \, too)
-	       (while ;;(or (eq (preceding-char) ?\,)
-			  (and (eq (preceding-char) ?:)
-			       (or;;(eq (char-after (- (point) 2)) ?\') ; ????
-				(memq (char-syntax (char-after (- (point) 2)))
-				      '(?w ?_))))
-			  ;;)
-		 (if (eq (preceding-char) ?\,)
-		     ;; Will go to beginning of line, essentially.
-		     ;; Will ignore embedded sexpr XXXX.
-		     (cperl-backward-to-start-of-continued-exp containing-sexp))
-		 (beginning-of-line)
-		 (cperl-backward-to-noncomment containing-sexp))
-	       ;; Now we get the answer.
-	       (if (not (or (eq (1- (point)) containing-sexp)
-			    (memq (preceding-char)
-				  (append (if is-block " ;{" " ,;{") '(nil)))
-			    (and (eq (preceding-char) ?\})
-				 (cperl-after-block-and-statement-beg
-				  containing-sexp))))
-		   ;; This line is continuation of preceding line's statement;
-		   ;; indent  `cperl-continued-statement-offset'  more than the
-		   ;; previous line of the statement.
-		   ;;
-		   ;; There might be a label on this line, just
-		   ;; consider it bad style and ignore it.
-		   (progn
-		     (cperl-backward-to-start-of-continued-exp containing-sexp)
-		     (+ (if (memq char-after (append "}])" nil))
-			    0		; Closing parenth
-			  cperl-continued-statement-offset)
-			(if (or is-block
-				(not delim)
-				(not (eq char-after ?\})))
-			    0
-			  ;; Now it is a hash reference
-			  (+ cperl-indent-level cperl-close-paren-offset))
-			(if (looking-at "\\w+[ \t]*:")
-			    (if (> (current-indentation) cperl-min-label-indent)
-				(- (current-indentation) cperl-label-offset)
-			      ;; Do not move `parse-data', this should
-			      ;; be quick anyway (this comment comes
-			      ;; from different location):
-			      (cperl-calculate-indent))
-			  (current-column))
-			(if (eq char-after ?\{)
-			    cperl-continued-brace-offset 0)))
-		 ;; This line starts a new statement.
-		 ;; Position following last unclosed open.
-		 (goto-char containing-sexp)
-		 ;; Is line first statement after an open-brace?
-		 (or
-		  ;; If no, find that first statement and indent like
-		  ;; it.  If the first statement begins with label, do
-		  ;; not believe when the indentation of the label is too
-		  ;; small.
-		  (save-excursion
-		    (forward-char 1)
-		    (setq old-indent (current-indentation))
-		    (let ((colon-line-end 0))
-		      (while (progn (skip-chars-forward " \t\n")
-				    (looking-at "#\\|[a-zA-Z0-9_$]*:[^:]"))
-			;; Skip over comments and labels following openbrace.
-			(cond ((= (following-char) ?\#)
-			       (forward-line 1))
-			      ;; label:
-			      (t
-			       (save-excursion (end-of-line)
-					       (setq colon-line-end (point)))
-			       (search-forward ":"))))
-		      ;; The first following code counts
-		      ;; if it is before the line we want to indent.
-		      (and (< (point) indent-point)
-			   (if (> colon-line-end (point)) ; After label
-			       (if (> (current-indentation)
-				      cperl-min-label-indent)
-				   (- (current-indentation) cperl-label-offset)
-				 ;; Do not believe: `max' is involved
-				 (+ old-indent cperl-indent-level))
-			     (current-column)))))
-		  ;; If no previous statement,
-		  ;; indent it relative to line brace is on.
-		  ;; For open brace in column zero, don't let statement
-		  ;; start there too.  If cperl-indent-level is zero,
-		  ;; use cperl-brace-offset + cperl-continued-statement-offset instead.
-		  ;; For open-braces not the first thing in a line,
-		  ;; add in cperl-brace-imaginary-offset.
-
-		  ;; If first thing on a line:  ?????
-		  (+ (if (and (bolp) (zerop cperl-indent-level))
-			 (+ cperl-brace-offset cperl-continued-statement-offset)
-		       cperl-indent-level)
-		     (if (or is-block
-			     (not delim)
-			     (not (eq char-after ?\})))
-			 0
-		       ;; Now it is a hash reference
-		       (+ cperl-indent-level cperl-close-paren-offset))
-		     ;; Move back over whitespace before the openbrace.
-		     ;; If openbrace is not first nonwhite thing on the line,
-		     ;; add the cperl-brace-imaginary-offset.
-		     (progn (skip-chars-backward " \t")
-			    (if (bolp) 0 cperl-brace-imaginary-offset))
-		     ;; If the openbrace is preceded by a parenthesized exp,
-		     ;; move to the beginning of that;
-		     ;; possibly a different line
+		(t
+		 ;; Statement level.  Is it a continuation or a new statement?
+		 ;; Find previous non-comment character.
+		 (goto-char pre-indent-point)
+		 (cperl-backward-to-noncomment containing-sexp)
+		 ;; Back up over label lines, since they don't
+		 ;; affect whether our line is a continuation.
+		 ;; (Had \, too)
+		 (while	;;(or (eq (preceding-char) ?\,)
+		     (and (eq (preceding-char) ?:)
+			  (or ;;(eq (char-after (- (point) 2)) ?\') ; ????
+			   (memq (char-syntax (char-after (- (point) 2)))
+				 '(?w ?_))))
+		   ;;)
+		   (if (eq (preceding-char) ?\,)
+		       ;; Will go to beginning of line, essentially.
+		       ;; Will ignore embedded sexpr XXXX.
+		       (cperl-backward-to-start-of-continued-exp containing-sexp))
+		   (beginning-of-line)
+		   (cperl-backward-to-noncomment containing-sexp))
+		 ;; Now we get the answer.
+		 (if (not (or (eq (1- (point)) containing-sexp)
+			      (memq (preceding-char)
+				    (append (if is-block " ;{" " ,;{") '(nil)))
+			      (and (eq (preceding-char) ?\})
+				   (cperl-after-block-and-statement-beg
+				    containing-sexp))))
+		     ;; This line is continuation of preceding line's statement;
+		     ;; indent  `cperl-continued-statement-offset'  more than the
+		     ;; previous line of the statement.
+		     ;;
+		     ;; There might be a label on this line, just
+		     ;; consider it bad style and ignore it.
 		     (progn
-		       (if (eq (preceding-char) ?\))
-			   (forward-sexp -1))
-		       ;; In the case it starts a subroutine, indent with
-		       ;; respect to `sub', not with respect to the
-		       ;; first thing on the line, say in the case of
-		       ;; anonymous sub in a hash.
-		       ;;
-		       (skip-chars-backward " \t")
-		       (if (and (eq (preceding-char) ?b)
-				(progn
-				  (forward-sexp -1)
-				  (looking-at "sub\\>"))
-				(setq old-indent
-				      (nth 1
-					   (parse-partial-sexp
-					    (save-excursion (beginning-of-line) (point))
-					    (point)))))
-			   (progn (goto-char (1+ old-indent))
-				  (skip-chars-forward " \t")
-				  (current-column))
-			 ;; Get initial indentation of the line we are on.
-			 ;; If line starts with label, calculate label indentation
-			 (if (save-excursion
-			       (beginning-of-line)
-			       (looking-at "[ \t]*[a-zA-Z_][a-zA-Z_0-9]*:[^:]"))
-			     (if (> (current-indentation) cperl-min-label-indent)
-				 (- (current-indentation) cperl-label-offset)
-			       ;; Do not move `parse-data', this should
-			       ;; be quick anyway:
-			       (cperl-calculate-indent))
-			   (current-indentation))))))))))))))
+		       (cperl-backward-to-start-of-continued-exp containing-sexp)
+		       (+ (if (memq char-after (append "}])" nil))
+			      0		; Closing parenth
+			    cperl-continued-statement-offset)
+			  (if (or is-block
+				  (not delim)
+				  (not (eq char-after ?\})))
+			      0
+			    ;; Now it is a hash reference
+			    (+ cperl-indent-level cperl-close-paren-offset))
+			  (if (looking-at "\\w+[ \t]*:")
+			      (if (> (current-indentation) cperl-min-label-indent)
+				  (- (current-indentation) cperl-label-offset)
+				;; Do not move `parse-data', this should
+				;; be quick anyway (this comment comes
+				;; from different location):
+				(cperl-calculate-indent))
+			    (current-column))
+			  (if (eq char-after ?\{)
+			      cperl-continued-brace-offset 0)))
+		   ;; This line starts a new statement.
+		   ;; Position following last unclosed open.
+		   (goto-char containing-sexp)
+		   ;; Is line first statement after an open-brace?
+		   (or
+		    ;; If no, find that first statement and indent like
+		    ;; it.  If the first statement begins with label, do
+		    ;; not believe when the indentation of the label is too
+		    ;; small.
+		    (save-excursion
+		      (forward-char 1)
+		      (setq old-indent (current-indentation))
+		      (let ((colon-line-end 0))
+			(while (progn (skip-chars-forward " \t\n")
+				      (looking-at "#\\|[a-zA-Z0-9_$]*:[^:]"))
+			  ;; Skip over comments and labels following openbrace.
+			  (cond ((= (following-char) ?\#)
+				 (forward-line 1))
+				;; label:
+				(t
+				 (save-excursion (end-of-line)
+						 (setq colon-line-end (point)))
+				 (search-forward ":"))))
+			;; The first following code counts
+			;; if it is before the line we want to indent.
+			(and (< (point) indent-point)
+			     (if (> colon-line-end (point)) ; After label
+				 (if (> (current-indentation)
+					cperl-min-label-indent)
+				     (- (current-indentation) cperl-label-offset)
+				   ;; Do not believe: `max' is involved
+				   (+ old-indent cperl-indent-level))
+			       (current-column)))))
+		    ;; If no previous statement,
+		    ;; indent it relative to line brace is on.
+		    ;; For open brace in column zero, don't let statement
+		    ;; start there too.  If cperl-indent-level is zero,
+		    ;; use cperl-brace-offset + cperl-continued-statement-offset instead.
+		    ;; For open-braces not the first thing in a line,
+		    ;; add in cperl-brace-imaginary-offset.
+
+		    ;; If first thing on a line:  ?????
+		    (+ (if (and (bolp) (zerop cperl-indent-level))
+			   (+ cperl-brace-offset cperl-continued-statement-offset)
+			 cperl-indent-level)
+		       (if (or is-block
+			       (not delim)
+			       (not (eq char-after ?\})))
+			   0
+			 ;; Now it is a hash reference
+			 (+ cperl-indent-level cperl-close-paren-offset))
+		       ;; Move back over whitespace before the openbrace.
+		       ;; If openbrace is not first nonwhite thing on the line,
+		       ;; add the cperl-brace-imaginary-offset.
+		       (progn (skip-chars-backward " \t")
+			      (if (bolp) 0 cperl-brace-imaginary-offset))
+		       ;; If the openbrace is preceded by a parenthesized exp,
+		       ;; move to the beginning of that;
+		       ;; possibly a different line
+		       (progn
+			 (if (eq (preceding-char) ?\))
+			     (forward-sexp -1))
+			 ;; In the case it starts a subroutine, indent with
+			 ;; respect to `sub', not with respect to the
+			 ;; first thing on the line, say in the case of
+			 ;; anonymous sub in a hash.
+			 ;;
+			 (skip-chars-backward " \t")
+			 (if (and (eq (preceding-char) ?b)
+				  (progn
+				    (forward-sexp -1)
+				    (looking-at "sub\\>"))
+				  (setq old-indent
+					(nth 1
+					     (parse-partial-sexp
+					      (save-excursion (beginning-of-line) (point))
+					      (point)))))
+			     (progn (goto-char (1+ old-indent))
+				    (skip-chars-forward " \t")
+				    (current-column))
+			   ;; Get initial indentation of the line we are on.
+			   ;; If line starts with label, calculate label indentation
+			   (if (save-excursion
+				 (beginning-of-line)
+				 (looking-at "[ \t]*[a-zA-Z_][a-zA-Z_0-9]*:[^:]"))
+			       (if (> (current-indentation) cperl-min-label-indent)
+				   (- (current-indentation) cperl-label-offset)
+				 ;; Do not move `parse-data', this should
+				 ;; be quick anyway:
+				 (cperl-calculate-indent))
+			     (current-indentation))))))))))))))
 
 (defvar cperl-indent-alist
   '((string nil)
@@ -2725,9 +2709,9 @@
 				     (point)))
 			     (cons (list 'expression containing-sexp) res))))
 	    ((progn
-	      ;; Containing-expr starts with \{.  Check whether it is a hash.
-	      (goto-char containing-sexp)
-	      (not (cperl-block-p)))
+	       ;; Containing-expr starts with \{.  Check whether it is a hash.
+	       (goto-char containing-sexp)
+	       (not (cperl-block-p)))
 	     (setq res (cons (list 'expression-blanks
 				   (progn
 				     (goto-char (1+ containing-sexp))
@@ -2748,7 +2732,7 @@
 			(save-excursion (cperl-after-label)))
 	       (if (eq (preceding-char) ?\,)
 		   ;; Will go to beginning of line, essentially
-		     ;; Will ignore embedded sexpr XXXX.
+		   ;; Will ignore embedded sexpr XXXX.
 		   (cperl-backward-to-start-of-continued-exp containing-sexp))
 	       (beginning-of-line)
 	       (cperl-backward-to-noncomment containing-sexp))
@@ -2848,43 +2832,42 @@
   "Go to position before comment on the current line, or to end of line.
 Returns true if comment is found."
   (let (state stop-in cpoint (lim (progn (end-of-line) (point))))
-      (beginning-of-line)
-      (if (or
-	   (eq (get-text-property (point) 'syntax-type) 'pod)
-	   (re-search-forward "\\=[ \t]*\\(#\\|$\\)" lim t))
-	  (if (eq (preceding-char) ?\#) (progn (backward-char 1) t))
-	;; Else
-	(while (not stop-in)
-	  (setq state (parse-partial-sexp (point) lim nil nil nil t))
+    (beginning-of-line)
+    (if (or
+	 (eq (get-text-property (point) 'syntax-type) 'pod)
+	 (re-search-forward "\\=[ \t]*\\(#\\|$\\)" lim t))
+	(if (eq (preceding-char) ?\#) (progn (backward-char 1) t))
+      ;; Else
+      (while (not stop-in)
+	(setq state (parse-partial-sexp (point) lim nil nil nil t))
 					; stop at comment
-	  ;; If fails (beginning-of-line inside sexp), then contains not-comment
-	  (if (nth 4 state)		; After `#';
+	;; If fails (beginning-of-line inside sexp), then contains not-comment
+	(if (nth 4 state)		; After `#';
 					; (nth 2 state) can be
 					; beginning of m,s,qq and so
 					; on
-	      (if (nth 2 state)
-		  (progn
-		    (setq cpoint (point))
-		    (goto-char (nth 2 state))
-		    (cond
-		     ((looking-at "\\(s\\|tr\\)\\>")
-		      (or (re-search-forward
-			   "\\=\\w+[ \t]*#\\([^\n\\\\#]\\|\\\\[\\\\#]\\)*#\\([^\n\\\\#]\\|\\\\[\\\\#]\\)*"
-			   lim 'move)
-			  (setq stop-in t)))
-		     ((looking-at "\\(m\\|q\\([qxwr]\\)?\\)\\>")
-		      (or (re-search-forward
-			   "\\=\\w+[ \t]*#\\([^\n\\\\#]\\|\\\\[\\\\#]\\)*#"
-			   lim 'move)
-			  (setq stop-in t)))
-		     (t			; It was fair comment
-		      (setq stop-in t)	; Finish
-		      (goto-char (1- cpoint)))))
-		(setq stop-in t)	; Finish
-		(forward-char -1))
-	    (setq stop-in t))		; Finish
-	  )
-	(nth 4 state))))
+	    (if (nth 2 state)
+		(progn
+		  (setq cpoint (point))
+		  (goto-char (nth 2 state))
+		  (cond
+		   ((looking-at "\\(s\\|tr\\)\\>")
+		    (or (re-search-forward
+			 "\\=\\w+[ \t]*#\\([^\n\\\\#]\\|\\\\[\\\\#]\\)*#\\([^\n\\\\#]\\|\\\\[\\\\#]\\)*"
+			 lim 'move)
+			(setq stop-in t)))
+		   ((looking-at "\\(m\\|q\\([qxwr]\\)?\\)\\>")
+		    (or (re-search-forward
+			 "\\=\\w+[ \t]*#\\([^\n\\\\#]\\|\\\\[\\\\#]\\)*#"
+			 lim 'move)
+			(setq stop-in t)))
+		   (t			; It was fair comment
+		    (setq stop-in t)	; Finish
+		    (goto-char (1- cpoint)))))
+	      (setq stop-in t)		; Finish
+	      (forward-char -1))
+	  (setq stop-in t)))		; Finish 
+      (nth 4 state))))
 
 (defsubst cperl-1- (p)
   (max (point-min) (1- p)))
@@ -3008,7 +2991,7 @@
 		(setq set-st nil)
 		(setq ender (cperl-forward-re lim end nil t st-l err-l
 					      argument starter ender)
-		 ender (nth 2 ender)))))
+		      ender (nth 2 ender)))))
       (error (goto-char lim)
 	     (setq set-st nil)
 	     (if reset-st
@@ -3035,7 +3018,7 @@
   ;; Do after syntactic fontification?
   (if cperl-syntaxify-by-font-lock
       (or now (put-text-property b e 'cperl-postpone (cons type val)))
-      (put-text-property b e type val)))
+    (put-text-property b e type val)))
 
 ;;; Here is how the global structures (those which cannot be
 ;;; recognized locally) are marked:
